Uses UniGr, Crt, Colors, Keyb;
Const
     MaxStar = 200;
     MaxLines = 255;
     MaxPicture = 60;
     MaxFire = 16;
Type StarType = record
       X, Y, Spd : Real;
       Color : Byte;
       _X, _Y : Integer;
     End;
     FireType = record
       X, Y : Real;
       Spd : Real;
       Vector : Real;
       Profile : Integer;
       _X, _Y : Integer;
       On : Byte;
     End;
Var Star : Array[1..MaxStar] of StarType;
    Fire : Array[1..MaxFire] of FireType;
    MyScreen : PScreen;
    Map : Array[1..10, 1..MaxLines] Of Char;
    MapLeng : Integer;
    Palette : Array[0..3*255] Of Byte;
    Picture : Array[1..MaxPicture] Of Pointer;

Procedure LoadMap;
Var F : Text;
    Line : String;
    I : Integer;
Begin
  Assign(F, 'mapa.bin');
  Reset(F);
  MapLeng := 0;
  While not Eof(F) do
  Begin
    Inc(MapLeng);
    ReadLn(F, Line);
    For I := 1 to 10 do
      Map[I, MapLeng] := Line[I];
  End;
  Close(F);
End;
Function Conv(Ch : Char) : Integer;
Begin
  Conv := 0;
  If Ch = 'a' Then Conv := 01;
  If Ch = 'b' Then Conv := 11;
  If Ch = 'c' Then Conv := 21;
  If Ch = 'd' Then Conv := 31;
  If Ch = 'A' Then Conv := 02;
  If Ch = 'B' Then Conv := 12;
  If Ch = 'C' Then Conv := 22;
  If Ch = 'D' Then Conv := 32;

  If Ch = 'e' Then Conv := 03;
  If Ch = 'f' Then Conv := 04;
  If Ch = 'g' Then Conv := 05;
  If Ch = 'h' Then Conv := 06;
  If Ch = 'E' Then Conv := 13;
  If Ch = 'F' Then Conv := 14;
  If Ch = 'G' Then Conv := 15;
  If Ch = 'H' Then Conv := 16;

  If Ch = 'o' Then Conv := 41;
  If Ch = 'O' Then Conv := 42;
  If Ch = 'l' Then Conv := 51;
  If Ch = 'L' Then Conv := 52;

  If Ch = 'i' Then Conv := 43;
  If Ch = 'I' Then Conv := 44;
  If Ch = 'k' Then Conv := 53;
  If Ch = 'K' Then Conv := 54;

  If Ch = '0' Then Conv := 23;

End;

Procedure GenerateStar(I, Pos : Integer);
Begin
  Star[I]._X := random(320-1)+1;
  If Pos > 0 Then Star[I]._Y := 0;
  If Pos < 0 Then Star[I]._Y := 200;
  If Pos = 0 Then Star[I]._Y := Random(200);
  Star[I].Spd := Random(100)/100;
  Star[I].Color := 208+Trunc(Star[I].Spd*8);
  Star[I].X := Star[I]._X;
  Star[I].Y := Star[I]._Y;
End;
Procedure MoveStar(I : Integer; Dir : Real);
Begin
  If Dir = 0 Then Exit;
  Star[I].Y := Star[I].Y + Star[I].Spd*Dir;
  If (Dir > 0) And (Star[I].Y > 200) Then
    GenerateStar(I, +1);
  If (Dir < 0) And (Star[I].Y < 0) Then
    GenerateStar(I, -1);
  Star[I]._Y := Trunc(Star[I].Y);
End;
Procedure ShowStar(I : Integer);
Begin
  PutPixel(MyScreen, Star[I]._X, Star[I]._Y, Star[I].Color);
End;

Procedure InitStars;
Var I : Integer;
Begin
  For I := 1 to MaxStar do
    GenerateStar(I, 0);
End;
Procedure InitFires;
Var I : Integer;
Begin
  For I := 1 to MaxFire do
    Fire[I].On := 0;
End;
Procedure ShowFires;
Var I : Integer;
Begin
  For I := 1 to MaxFire do
    If (Fire[I].On = 1) Then
    Begin
      PutImgNull(MyScreen, Fire[I]._X-16, Fire[I]._Y-16, Picture[Fire[I].Profile]);
    End;
End;
Procedure MoveFires;
Var I : Integer;
Begin
  For I := 1 to MaxFire do
    If (Fire[I].On = 1) Then
    Begin
      If Fire[I]._Y < -16 Then Fire[I].On := 0;
      Fire[I].Y := Fire[I].Y - Fire[I].Spd*4;
      Fire[I].X := Fire[I].X + Fire[I].Vector;
      Fire[I]._X := Trunc(Fire[I].X);
      Fire[I]._Y := Trunc(Fire[I].Y);
    End;
End;

Procedure NewFire(X, Y : Integer; Vector : Real);
Var I : Integer;
Begin
  For I := 1 to MaxFire do
    If (Fire[I].On = 0) Then
    Begin
      Fire[I].On := 1;
      Fire[I].X := X;
      Fire[I].Y := Y;
      Fire[I]._X := X;
      Fire[I]._Y := Y;
      Fire[I].Spd := 0.9;
      Fire[I].Vector := Vector;
      Fire[I].Profile := 33;
      Break;
    End;
End;
Procedure MoveStars(Dir : Real);
Var I : Integer;
Begin
  For I := 1 to MaxStar do
    MoveStar(I, Dir);
End;
Procedure ShowStars;
Var I : Integer;
Begin
  For I := 1 to MaxStar do
    ShowStar(I);
End;
Var Speed : Real;
    MainPos : Real;
    _MainPos : Integer;
    I, X, Y, Pic, mX, mY : Integer;
    SubMoved : Integer;
    Shift : Integer;
    ShipX, ShipY : Real;
    ShipDir : Integer;
    ShipDX : Real;
    _ShipX, _ShipY : Integer;

    tx, ty : Integer;

Function Test : Boolean;
Var _MainPos, SubMoved, Shift, _ShipX, _ShipY : Integer;
     Obj : Char;
     OffsX, OffsY : Integer;
     Pix : Byte;
     Pic : Integer;
Begin
    _MainPos := Trunc(MainPos - Speed*2);
    SubMoved := _MainPos div 32;
    Shift := - _MainPos mod 32;
    _ShipX := Trunc(ShipX+ShipDX);
    _ShipY := {static} Trunc(ShipY);

    tx := _ShipX div 32 + 1;
    ty := (_ShipY - Shift) div 32 + SubMoved +1;
    OffsX := _ShipX mod 32;
    OffsY := (_ShipY - Shift) mod 32;
    If OffsY < 0 Then halt;

    Obj := #0;
        If (ty > 0) And (ty <= MapLeng) And
           (tx > 0) And (tx <= 10) Then
           Obj := Map[tX, tY];

  If (Obj = #0) Or (Obj = ' ') Then
    Test := True
  Else
  Begin
    Pic := Conv(Obj);
    Pix := PArray(Picture[Pic])^[2+OffsX+OffsY*32];
    If Pix = 0 Then Test := True Else Test := False;
  End;
End;

Var Clk : Byte;
Begin
  LoadMap;
  InitScreen(MyScreen);
  GraphMode;
  DrawPCX(Screen, '0000009.PCX', 0, 0, Palette);
  For I := 0 to 255 do
    SetRGB256(I, Palette[I*3+0],
                 Palette[I*3+1],
                 Palette[I*3+2]);
  For I := 1 to MaxPicture do
  Begin
    InitPicture(Picture[I], 0, 0, 64, 64);
    GetImg(Screen, ((I-1) mod 10)*32, ((I-1) div 10)*32,
                   ((I-1) mod 10)*32+32, ((I-1) div 10)*32+32, Picture[I]);
  End;

  InitStars;
  Speed := 0;
  MainPos := MapLeng*32-5*32;
  ShipDir := 0;
  ShipX := 160;
  ShipY := 180;
  InitKey;
  While not Kb^[1] do
  Begin
    Inc(Clk);
    If Keypressed Then ReadKey;
    ShipDir := 0;
    If (Kb^[2]) And (Fire[1].On = 0) Then NewFire(_ShipX, _ShipY, ShipDX/4);
    If Kb^[75] Then ShipDir := -1;
    If Kb^[77] Then ShipDir := +1;
    If Kb^[72] Then
    Begin
      Speed := Speed + 0.08;
      If Speed < 0 Then Speed := Speed + 0.04;
    End else
    If Kb^[80] Then
    Begin
      Speed := Speed - 0.08;
      If Speed > 0 Then Speed := Speed - 0.04;
    End else
    Begin
      If Speed > +0.06 Then Speed := Speed - 0.06 else
      If Speed < -0.06 Then Speed := Speed + 0.06 else
        Speed := 0;
    End;

    If Speed > 2 Then Speed := 2;
    If Speed < -2 Then Speed := -2;
    Clear(MyScreen);

    If Test Then
    Begin
      MoveStars(Speed);
      MainPos := MainPos - Speed*2;
      _MainPos := Trunc(MainPos);
      SubMoved := _MainPos div 32;
      Shift :=  - _MainPos mod 32;
      ShipX := ShipX + ShipDX;
    End Else
    Begin
      If Abs(ShipDX) > Abs(Speed) Then
        ShipDX := - ShipDX / 2
      Else
        Speed := - Speed / 2;
    End;
    ShowStars;
    ShowFires;
    MoveFires;
{    If Clk mod 2 = 1 Then}
    For Y := 1 to 8 Do
      For X := 1 to 10 Do
      Begin
        mX := X;
        mY := Y+SubMoved;
        Pic := 0;
        If (mY > 0) And (mY <= MapLeng) Then
        Begin
          Pic := Conv(Map[mX, mY]);
        End;
        If (Pic <> 0) And (Y < 200) Then
          PutImgNULL(MyScreen, X*32-32, Y*32-32+Shift, Picture[Pic]);
      end;
    If ShipDir <> 0 Then
    Begin
      If Abs(ShipDX) < 3 Then ShipDX := ShipDX + ShipDir*0.2;
    End Else
    Begin
      If ShipDX > +0.4 Then ShipDX := ShipDX - 0.4 else
      If ShipDX < -0.4 Then ShipDX := ShipDX + 0.4 else
        ShipDX := 0;
    End;
    If ShipX < 0 Then ShipX := 0;
    If ShipX > 320 Then ShipX := 320;
    _ShipX := Trunc(ShipX);
    _ShipY := Trunc(ShipY);

{    If Clk mod 2 = 1 Then}
    Begin
      If ShipDir = 0 Then
        PutImgNull(MyScreen, _ShipX-16, _ShipY-16, Picture[24]) Else
      If ShipDir = -1 Then
        PutImgNull(MyScreen, _ShipX-16, _ShipY-16, Picture[26]) Else
      If ShipDir = +1 Then
        PutImgNull(MyScreen, _ShipX-16, _ShipY-16, Picture[25]);
      Blit(Screen, MyScreen);
    End;
  End;
  DoneKey;
  UniGr.TextMode;
End.