Uses UniGr, Crt;
Const
     MaxStar = 200;
Type StarType = record
       X, Y, Spd : Real;
       Color : Byte;
       _X, _Y : Integer;
     End;
Var Star : Array[1..MaxStar] of StarType;
    MyScreen : PScreen;
Procedure GenerateStar(I, Pos : Integer);
Begin
  Star[I]._X := random(320-1)+1;
  If Pos > 0 Then Star[I]._Y := 0;
  If Pos < 0 Then Star[I]._Y := 200;
  If Pos = 0 Then Star[I]._Y := Random(200);
  Star[I].Spd := Random(100)/100;
  Star[I].Color := 16+Trunc(Star[I].Spd*16);
  Star[I].X := Star[I]._X;
  Star[I].Y := Star[I]._Y;
End;
Procedure MoveStar(I : Integer; Dir : Real);
Begin
  If Dir = 0 Then Exit;
  Star[I].Y := Star[I].Y + Star[I].Spd*Dir;
  If (Dir > 0) And (Star[I].Y > 200) Then
    GenerateStar(I, +1);
  If (Dir < 0) And (Star[I].Y < 0) Then
    GenerateStar(I, -1);
  Star[I]._Y := Trunc(Star[I].Y);
End;
Procedure ShowStar(I : Integer);
Begin
  PutPixel(MyScreen, Star[I]._X, Star[I]._Y, Star[I].Color);
End;

Procedure InitStars;
Var I : Integer;
Begin
  For I := 1 to MaxStar do
    GenerateStar(I, 0);
End;
Procedure MoveStars(Dir : Real);
Var I : Integer;
Begin
  For I := 1 to MaxStar do
    MoveStar(I, Dir);
End;
Procedure ShowStars;
Var I : Integer;
Begin
  For I := 1 to MaxStar do
    ShowStar(I);
End;
Var Speed : Real;
    MainPos : Real;
Begin
  {ovlada sa : ESC, 1, 2}
  InitScreen(MyScreen);
  GraphMode;
  InitStars;
  Speed := 0;
  While port[$60] <> 1 do
  Begin
    If Keypressed Then ReadKey;
    If Port[$60] = 2 Then
    Begin
      If Speed < 1 Then Speed := Speed + 0.03;
    End else
    If Port[$60] = 3 Then
    Begin
      If Speed > -1 Then Speed := Speed - 0.03
    End else
    Begin
      If Speed > +0.02 Then Speed := Speed - 0.02 else
      If Speed < -0.02 Then Speed := Speed + 0.02 else
        Speed := 0;
    End;
    Clear(MyScreen);
    MoveStars(Speed);
    ShowStars;

    MainPos := MainPos + Speed;
    If MainPos > 200 Then MainPos := MainPos - 200;
    If MainPos < 0 Then MainPos := MainPos + 200;

    Line(MyScreen, 100, Trunc(MainPos), 220, Trunc(MainPos), 32);
    Blit(Screen, MyScreen);
  End;
  UniGr.TextMode;
End.